package com.zhongzheng.modules.course.service;


import com.baomidou.mybatisplus.extension.service.IService;
import com.zhongzheng.modules.course.bo.CourseAddBo;
import com.zhongzheng.modules.course.bo.CourseEditBo;
import com.zhongzheng.modules.course.bo.CourseQueryBo;
import com.zhongzheng.modules.course.domain.Course;
import com.zhongzheng.modules.course.vo.CourseVo;
import com.zhongzheng.modules.exam.bo.ExamNoteQueryBo;
import com.zhongzheng.modules.exam.vo.ExamNoteVo;
import com.zhongzheng.modules.order.bo.CouponQueryBo;
import com.zhongzheng.modules.order.vo.CouponVo;

import java.util.Collection;
import java.util.List;
import java.util.Map;

/**
 * 课程Service接口
 *
 * @author ruoyi
 * @date 2021-05-19
 */
public interface ICourseService extends IService<Course> {
	/**
	 * 查询单个
	 * @return
	 */
	CourseVo queryById(Long courseId);


	/**
	 * 查询列表
	 */
	List<CourseVo> queryList(CourseQueryBo bo);

	List<CourseVo> queryRecommendList(CourseQueryBo bo);

	List<CourseVo> selectCourseList(CourseQueryBo bo);

	/**
	 * 根据新增业务对象插入课程
	 * @param bo 课程新增业务对象
	 * @return
	 */
	Long insertByAddBo(CourseAddBo bo);

	/**
	 * 根据编辑业务对象修改课程
	 * @param bo 课程编辑业务对象
	 * @return
	 */
	Boolean updateByEditBo(CourseEditBo bo);

	/**
	 * 校验并删除数据
	 * @param ids 主键集合
	 * @param isValid 是否校验,true-删除前校验,false-不校验
	 * @return
	 */
	Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid);
}
